"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateRandomBytes;

var _reactNative = require("react-native");

var _cryptoJs = _interopRequireDefault(require("crypto-js"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @ts-ignore
function generateRandomBytes() {
  if (_reactNative.NativeModules.ExpoRandom) {
    const bytes = _reactNative.NativeModules.ExpoRandom.getRandomBase64String(_utils.BYTE_LENGTH);

    return bytes;
  }

  if (global.ExpoModules) {
    const bytes = global.ExpoModules.ExpoRandom.getRandomBase64String(_utils.BYTE_LENGTH);
    return bytes;
  }

  if (global.RNPkceChallenge) {
    const bytes = global.RNPkceChallenge.randomBytes();
    return bytes;
  }

  const buffer = _cryptoJs.default.lib.WordArray.random(_utils.BYTE_LENGTH);

  const bytes = buffer.toString(_cryptoJs.default.enc.Base64);
  return bytes;
}
//# sourceMappingURL=generate-random-bytes.native.js.map